"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.convertData = undefined;

var _index = require("../json/index");

/**
 * Created by Tien Nguyen on 11/29/16.
 */
/**
 * Get Value from object
 * @param objectBody
 * @param keyChange
 * @param changeOption
 * @param objectReturn
 * @returns {*}
 */
function getValueChangeOption(objectBody, keyChange, changeOption, objectReturn) {
    var value = objectBody[keyChange] ? objectBody[keyChange] : changeOption.$default;
    if (changeOption.$get) {
        return (0, _index.isJsonString)(value) ? JSON.parse(value) : value;
    }
    if (changeOption.$update) {
        return changeOption.$update(value, objectReturn);
    }
    if (changeOption.$set) {
        return changeOption.$set;
    }
}

/**
 * Parse body Object to data Object
 * @param objectBody
 * @param objectChange
 * @returns {{}}
 */
function convertData(objectBody, objectChange) {
    var keysChange = Object.keys(objectChange);
    var objectReturn = {};
    keysChange.map(function (keyChange) {
        var changeOption = objectChange[keyChange];
        var valueKeyReturn = getValueChangeOption(objectBody, keyChange, changeOption, objectReturn);
        if (valueKeyReturn !== undefined && valueKeyReturn !== null) {
            objectReturn[keyChange] = valueKeyReturn;
        }
        return keyChange;
    });
    return objectReturn;
}

exports.convertData = convertData;